/*
 * JPA DAO Template
 *
 *
 * Takatuka - Template fuer JPA DAO (Extended = ExtendedPersistenceContext ConversationScope (Group = EntityExtendedDAO.class)
 *
 */

package de.ivu.elect.business.gruppe.boundary;

import javax.inject.Inject;

import de.ivu.elect.business.gruppe.entity.Gruppe;
import de.ivu.elect.jee.entity.ExtendedDAO;

@javax.enterprise.context.RequestScoped
public class GruppeExtendedDAO extends AbstractGruppeDAO implements java.io.Serializable {

  private static final long serialVersionUID = 1L;

  @Inject
  transient ExtendedDAO extendedDAO;

  @Inject
  transient de.ivu.elect.presentation.system.ExtendedDAORequestCache cache;

  @Override
  protected javax.persistence.EntityManager getEntityManager() {
    return extendedDAO.getEntityManager();
  }

  @Override
  public void flush() {
    extendedDAO.flush();
  }

  public void flushNewTransaction() {
    extendedDAO.flushNewTransaction();
  }

/**
* Name: AllNoFlush<br>
* Beschreibung: <br>
* EJBQL: SELECT o FROM Gruppe o<br>
* SQL: <br>
*/
@Override
public java.util.List<Gruppe> findByAll() {

    if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES) {
      de.ivu.elect.presentation.system.FinderKey key = new de.ivu.elect.presentation.system.FinderKey("Gruppe.findByAll"  );

      if (!cache.contains(key)) {
        if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
          System.out.println("Query: " + getClass().getName() + ".findByAll(): Miss");
        }

        cache.put(key, super.findByAll( ));
      } else if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
        System.out.println("Query: " + getClass().getName() + ".findByAll(): Hit");
      }

      return new java.util.ArrayList<>((java.util.List<Gruppe>) cache.lookup(key));
    }

    return super.findByAll( );
}
/**
* Name: WahlAndGruppeArtenNoFlush<br>
* Beschreibung: <br>
* EJBQL: SELECT gruppe FROM Gruppe gruppe WHERE gruppe.wahl = ?1 AND gruppe.gruppeArt IN (?2)<br>
* SQL: <br>
*/
@Override
public java.util.List<Gruppe> findByWahlAndGruppeArten( @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahl wahl,  @javax.annotation.Nonnull java.util.Collection<de.ivu.elect.business.gruppe.entity.GruppeArt> gruppeArten) {

    if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES) {
      de.ivu.elect.presentation.system.FinderKey key = new de.ivu.elect.presentation.system.FinderKey("Gruppe.findByWahlAndGruppeArten" ,  wahl ,  gruppeArten  );

      if (!cache.contains(key)) {
        if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
          System.out.println("Query: " + getClass().getName() + ".findByWahlAndGruppeArten(): Miss");
        }

        cache.put(key, super.findByWahlAndGruppeArten( wahl ,  gruppeArten  ));
      } else if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
        System.out.println("Query: " + getClass().getName() + ".findByWahlAndGruppeArten(): Hit");
      }

      return new java.util.ArrayList<>((java.util.List<Gruppe>) cache.lookup(key));
    }

    return super.findByWahlAndGruppeArten( wahl ,  gruppeArten  );
}
/**
* Name: WahlAndKurznameNoFlush<br>
* Beschreibung: <br>
* EJBQL: SELECT o FROM Gruppe o WHERE o.wahl=?1 and o.kurzname=?2<br>
* SQL: <br>
*/
@Override
public Gruppe findByWahlAndKurzname( @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahl wahl,  @javax.annotation.Nonnull java.lang.String kurzname) {

    if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES) {
      de.ivu.elect.presentation.system.FinderKey key = new de.ivu.elect.presentation.system.FinderKey("Gruppe.findByWahlAndKurzname" ,  wahl ,  kurzname  );

      if (!cache.contains(key)) {
        if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
          System.out.println("Query: " + getClass().getName() + ".findByWahlAndKurzname(): Miss");
        }

        cache.put(key, super.findByWahlAndKurzname( wahl ,  kurzname  ));
      } else if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
        System.out.println("Query: " + getClass().getName() + ".findByWahlAndKurzname(): Hit");
      }

      return (Gruppe) cache.lookup(key);
    }

    return super.findByWahlAndKurzname( wahl ,  kurzname  );
}
/**
* Name: WahlAndSchluesselNoFlush<br>
* Beschreibung: <br>
* EJBQL: SELECT o FROM Gruppe o WHERE o.wahl=?1 and o.schluessel=?2<br>
* SQL: <br>
*/
@Override
public Gruppe findByWahlAndSchluessel( @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahl wahl,  @javax.annotation.Nonnull String schluessel) {

    if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES) {
      de.ivu.elect.presentation.system.FinderKey key = new de.ivu.elect.presentation.system.FinderKey("Gruppe.findByWahlAndSchluessel" ,  wahl ,  schluessel  );

      if (!cache.contains(key)) {
        if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
          System.out.println("Query: " + getClass().getName() + ".findByWahlAndSchluessel(): Miss");
        }

        cache.put(key, super.findByWahlAndSchluessel( wahl ,  schluessel  ));
      } else if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
        System.out.println("Query: " + getClass().getName() + ".findByWahlAndSchluessel(): Hit");
      }

      return (Gruppe) cache.lookup(key);
    }

    return super.findByWahlAndSchluessel( wahl ,  schluessel  );
}
/**
* Name: WahlAndUngleichGruppeArtOrderBySchluesselNoFlush<br>
* Beschreibung: <br>
* EJBQL: SELECT g FROM Gruppe g WHERE g.wahl = ?1 AND g.gruppeArt != ?2 ORDER BY g.schluessel<br>
* SQL: <br>
*/
@Override
public java.util.List<Gruppe> findByWahlAndUngleichGruppeArtOrderBySchluessel( @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahl wahl,  @javax.annotation.Nonnull de.ivu.elect.business.gruppe.entity.GruppeArt gruppeArt) {

    if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES) {
      de.ivu.elect.presentation.system.FinderKey key = new de.ivu.elect.presentation.system.FinderKey("Gruppe.findByWahlAndUngleichGruppeArtOrderBySchluessel" ,  wahl ,  gruppeArt  );

      if (!cache.contains(key)) {
        if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
          System.out.println("Query: " + getClass().getName() + ".findByWahlAndUngleichGruppeArtOrderBySchluessel(): Miss");
        }

        cache.put(key, super.findByWahlAndUngleichGruppeArtOrderBySchluessel( wahl ,  gruppeArt  ));
      } else if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
        System.out.println("Query: " + getClass().getName() + ".findByWahlAndUngleichGruppeArtOrderBySchluessel(): Hit");
      }

      return new java.util.ArrayList<>((java.util.List<Gruppe>) cache.lookup(key));
    }

    return super.findByWahlAndUngleichGruppeArtOrderBySchluessel( wahl ,  gruppeArt  );
}
/**
* Name: WahlNoFlush<br>
* Beschreibung: <br>
* EJBQL: SELECT p FROM Gruppe p WHERE p.wahl = ?1<br>
* SQL: <br>
*/
@Override
public java.util.List<Gruppe> findByWahl( @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahl wahl) {

    if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES) {
      de.ivu.elect.presentation.system.FinderKey key = new de.ivu.elect.presentation.system.FinderKey("Gruppe.findByWahl" ,  wahl  );

      if (!cache.contains(key)) {
        if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
          System.out.println("Query: " + getClass().getName() + ".findByWahl(): Miss");
        }

        cache.put(key, super.findByWahl( wahl  ));
      } else if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
        System.out.println("Query: " + getClass().getName() + ".findByWahl(): Hit");
      }

      return new java.util.ArrayList<>((java.util.List<Gruppe>) cache.lookup(key));
    }

    return super.findByWahl( wahl  );
}

  @Override
  public void clear() {
    cache.clear();

    super.clear();
  }
}
